/*  zweic -- a compiler for Zwei
 *
 *  Stephane Micheloud & LAMP
 *
 *  $Id: GeneratorTest.java 2253 2005-11-19 18:55:44 +0100 (Sat, 19 Nov 2005) michelou $
 */

package zweic;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 * usage: java zweic.GeneratorTest <file.zwei> [ <file.risc> ]
 */
public class GeneratorTest {
    public static void main(String[] args) {
        if (args.length == 0) {
            System.err.println("usage: java zweic.GeneratorTest <file.zwei> [ <file.risc> ]");
            System.exit(1);
        }
        try {
            InputStreamReader in = (args.length < 1)
                ? new InputStreamReader(System.in)
                : new FileReader(args[0]);
            Tree tree = new Parser(in).parse();
            in.close();
            if (Report.errors > 0)
                System.err.println(Report.errors + " errors found." );
            else {
                new Analyzer().analyze(tree);
                if (Report.errors > 0)
                    System.err.println(Report.errors + " errors found." );
                else {
                    PrintWriter out = (args.length < 2)
                        ? new PrintWriter(System.out)
                        : new PrintWriter(new FileWriter(args[1]));
                    Code code = new Generator().gen(tree);
                    code.write(out);
                }
            }
            System.exit((Report.errors > 0) ? 1 : 0);
        }
        catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
